<?php

require_once(dirname(__FILE__).'/config.php');
require_once(dirname(__FILE__).'/option.php');

// ----------------------------------------------------------------------------
// the DiscloseSecret_PostMeta class handles the loading and storing of the
// plugin settings for each individual post including all needed conversion
// routines
// ----------------------------------------------------------------------------

class DiscloseSecret_PostMeta
{
	var $m_option;
	var $m_post_id;

	var $m_caps = array();
	var $m_roles = array();
	var $m_users = array();

	var $m_is_private;
	var $m_is_protected;

	// ----------------------------------------------------------------------------
	// init
	// ----------------------------------------------------------------------------

	function DiscloseSecret_PostMeta($post_id, &$option)
	{
		$this->m_option = $option;
		$this->m_post_id = $post_id;
		$this->load();
	}

	function save()
	{
		global $wpdb;

		// we don't update but recreate the whole postmetas because of lazyness
		$query = "
			DELETE FROM `{$wpdb->postmeta}`
			WHERE `post_id` = '{$this->m_post_id}'
			AND `meta_key` IN ('". DiscloseSecret_META_CAP. "'
				, '". DiscloseSecret_META_ROLE. "'
				, '". DiscloseSecret_META_USER. "')
		";
		$wpdb->query($query);

		foreach ($this->m_caps as $cap_id)
			add_post_meta($this->m_post_id, DiscloseSecret_META_CAP, $cap_id);
		foreach ($this->m_roles as $role_id)
			add_post_meta($this->m_post_id, DiscloseSecret_META_ROLE, $role_id);
		foreach ($this->m_users as $user_id)
			add_post_meta($this->m_post_id, DiscloseSecret_META_USER, $user_id);
	}

	function load()
	{
		$post = get_post($this->m_post_id);
		$this->m_caps  = get_post_meta($post->ID, DiscloseSecret_META_CAP, false);
		$this->m_roles = get_post_meta($post->ID, DiscloseSecret_META_ROLE, false);
		$this->m_users = get_post_meta($post->ID, DiscloseSecret_META_USER, false);

		$this->m_is_private = ($post->post_status == 'private'
			&& empty($this->m_caps) && empty($this->m_roles) && empty($this->m_users));
		$this->m_is_protected = ($post->post_status == 'private'
			&& (!empty($this->m_caps) || !empty($this->m_roles) || !empty($this->m_users)));
	}

	// ----------------------------------------------------------------------------
	// access
	// ----------------------------------------------------------------------------

	function set_from_POST()
	{
		$this->m_caps = array();
		foreach ($this->m_option->get_caps() as $cap)
		{
			if ($_POST[DiscloseSecret_POST_CAP. $cap[DiscloseSecret_INDEX_ID]])
				$this->m_caps[] = $cap[DiscloseSecret_INDEX_ID];
		}

		$this->m_roles = array();
		foreach ($this->m_option->get_roles() as $role)
		{
			if ($_POST[DiscloseSecret_POST_ROLE. $role[DiscloseSecret_INDEX_ID]])
				$this->m_roles[] = $role[DiscloseSecret_INDEX_ID];
		}

		$this->m_users = array();
		foreach ($this->m_option->get_users() as $user)
		{
			if ($_POST[DiscloseSecret_POST_USER. $user[DiscloseSecret_INDEX_ID]])
				$this->m_users[] = $user[DiscloseSecret_INDEX_ID];
		}
	}

	function &get_caps()
	{
		return $this->m_caps;
	}

	function &get_roles()
	{
		return $this->m_roles;
	}

	function &get_users()
	{
		return $this->m_users;
	}

	function is_private()
	{
		return $this->m_is_private;
	}

	function is_protected()
	{
		return $this->m_is_protected;
	}
}

?>